package com.bytesw.bytebot.controller;

import com.bytesw.bytebot.dto.AirportDto;
import com.bytesw.bytebot.dto.DataPage;
import com.bytesw.bytebot.service.AirportService;
import com.bytesw.xdf.controller.BasicXDFController;
import com.bytesw.xdf.service.XDFService;
import com.bytesw.xdf.sql.beans.Pagination;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/service/airport")
public class AirportController extends BasicXDFController<AirportDto, Long> {


    @Autowired
    private AirportService airportService;
    @Autowired
    private GsonBuilder gsonBuilder;

    public AirportController(AirportService airportService) {
        super(airportService);
    }

    public ResponseEntity<String> findAllByPagination(@RequestBody Pagination<AirportDto> pagination) {
        Gson gson = gsonBuilder.create();
        DataPage<AirportDto> value = new DataPage<>();

        value.setData(airportService.getAll());
        return new ResponseEntity(value, HttpStatus.OK);
    }
}
