package com.bytesw.bytebot.controller;

import com.bytesw.bytebot.dto.DataPage;
import com.bytesw.bytebot.dto.ItineraryReservationDto;
import com.bytesw.bytebot.service.ItineraryReservationService;
import com.bytesw.xdf.controller.BasicXDFController;
import com.bytesw.xdf.sql.beans.Pagination;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/service/itinerarys")
public class ItineraryReservationController extends BasicXDFController<ItineraryReservationDto, Long> {


    @Autowired
    private ItineraryReservationService itineraryReservationService;
    @Autowired
    private GsonBuilder gsonBuilder;

    public ItineraryReservationController(ItineraryReservationService itineraryReservationService) {
        super(itineraryReservationService);
    }

    public ResponseEntity<String> findAllByPagination(@RequestBody Pagination<ItineraryReservationDto> pagination) {
        Gson gson = gsonBuilder.create();
        DataPage<ItineraryReservationDto> value = new DataPage<>();
        value.setData(itineraryReservationService.getAll());
        return new ResponseEntity(value, HttpStatus.OK);
    }

    public ResponseEntity<String> finAll(HttpServletRequest req) {
        return new ResponseEntity(this.itineraryReservationService.getAll(), HttpStatus.OK);
    }

    public ResponseEntity<String> findOne(@PathVariable("id") Long id, HttpServletRequest req) {
        return new ResponseEntity(this.itineraryReservationService.getById(id), HttpStatus.OK);
    }
}
