package com.bytesw.bytebot.controller;

import com.bytesw.bytebot.dto.DataPage;
import com.bytesw.bytebot.dto.PaymentDto;
import com.bytesw.bytebot.model.Payment;
import com.bytesw.bytebot.repository.IItineraryReservationRepository;
import com.bytesw.bytebot.repository.IPaymentRepository;
import com.bytesw.bytebot.service.PaymentService;
import com.bytesw.xdf.controller.BasicXDFController;
import com.bytesw.xdf.service.XDFService;
import com.bytesw.xdf.sql.beans.Pagination;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/service/payment")
public class PaymentController extends BasicXDFController<PaymentDto, Long> {


    @Autowired
    private PaymentService paymentService;
    @Autowired
    private IItineraryReservationRepository itineraryReservationRepository;
    @Autowired
    private IPaymentRepository paymentRepository;
    @Autowired
    private GsonBuilder gsonBuilder;

    public PaymentController(PaymentService paymentService) {
        super(paymentService);
    }

    @Override
    public ResponseEntity<String> findAllByPagination(@RequestBody Pagination<PaymentDto> pagination) {
        Gson gson = gsonBuilder.create();
        DataPage<PaymentDto> value = new DataPage<>();
        value.setData(paymentService.getAll());
        return new ResponseEntity(value, HttpStatus.OK);
    }

    @PostMapping("/reservations/{id}/payments")
    public ResponseEntity<String> addTag(@PathVariable(value = "id") Long id, @RequestBody Payment paymentReq) {
        Payment payment = itineraryReservationRepository.findById(id).map(itineraryReservation -> {
            Long paymentId = paymentReq.getId();
            Payment pay = paymentRepository.findById(paymentId).orElseThrow(null);
            itineraryReservation.addPayment(pay);
            itineraryReservationRepository.save(itineraryReservation);
            return pay;
        }).orElseThrow(null);
        return new ResponseEntity(HttpStatus.OK);
    }
}
