package com.bytesw.bytebot.model;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import javax.persistence.*;
import java.io.Serializable;
import java.util.List;

@Entity
@Table(name = "airports")
@Getter
@Setter
@EqualsAndHashCode
@ToString
public class Airport implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @Column(name="airport_code")
    private String airportCode;

    @Column(name="airport_name")
    private String airportName;

    @Column(name="airport_location")
    private String airportLocation;

    @Column(name="other_details")
    private String details;

    @OneToMany(mappedBy = "codeAirportOrigin", cascade = CascadeType.ALL)
    private List<FlightSchedule> flights;

    @OneToMany(mappedBy = "codeAirportDestination", cascade = CascadeType.ALL)
    private List<FlightSchedule> flightsDes;

    @OneToMany(mappedBy = "codeAirportOrigin", cascade = CascadeType.ALL)
    private List<Leg> legs;

    @OneToMany(mappedBy = "codeAirportDestination", cascade = CascadeType.ALL)
    private List<Leg> legsDes;


}
