package com.bytesw.bytebot.service;

import com.bytesw.bytebot.dto.PassengerDto;
import com.bytesw.bytebot.model.Passenger;
import com.bytesw.bytebot.repository.IPassengerRepository;
import com.bytesw.xdf.service.XDFService;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class PassengerService  extends XDFService<Passenger, PassengerDto, Long> {
    protected PassengerService(IPassengerRepository passengerRepository) {
        super(passengerRepository);
    }

    @Override
    protected Passenger toModel(Passenger passenger, PassengerDto passengerDto) {
        if (passenger == null)
            passenger = new Passenger();
        BeanUtils.copyProperties(passengerDto, passenger);
        return passenger;
    }

    @Override
    protected PassengerDto toBean(Passenger passenger) {
        PassengerDto passengerDto = new PassengerDto();
        BeanUtils.copyProperties(passenger, passengerDto);
        return passengerDto;
    }
}
